blob: f60f766751036a941111841f48c8aa3d9b18fc8f [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Nicolas Geoffray1c5b6da2016-03-16 10:55:57 +000048export USE_JACK="true"
Alex Lightb55f1ac2016-04-12 15:50:55 -070049export SMALI_ARGS="--experimental"
jeffhao5d1ac922011-09-29 17:41:15 -070050
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070051# If dx was not set by the environment variable, assume it is in the path.
52if [ -z "$DX" ]; then
53 export DX="dx"
54fi
55
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080056# If jasmin was not set by the environment variable, assume it is in the path.
57if [ -z "$JASMIN" ]; then
58 export JASMIN="jasmin"
59fi
60
Andreas Gampe8fda9f22014-10-03 16:15:37 -070061# If smali was not set by the environment variable, assume it is in the path.
62if [ -z "$SMALI" ]; then
63 export SMALI="smali"
64fi
65
66# If dexmerger was not set by the environment variable, assume it is in the path.
67if [ -z "$DXMERGER" ]; then
68 export DXMERGER="dexmerger"
69fi
70
Sebastien Hertz19ac0272015-02-24 17:39:50 +010071# If jack was not set by the environment variable, assume it is in the path.
72if [ -z "$JACK" ]; then
73 export JACK="jack"
74fi
75
Sebastien Hertz19ac0272015-02-24 17:39:50 +010076# ANDROID_BUILD_TOP is not set in a build environment.
77if [ -z "$ANDROID_BUILD_TOP" ]; then
78 export ANDROID_BUILD_TOP=$oldwd
79fi
80
Andreas Gampef47fb2f2016-06-24 22:30:29 -070081# ANDROID_HOST_OUT is not set in a build environment.
82if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsenf325e012017-03-03 12:35:30 -080083 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070084fi
85
Sebastien Hertz19ac0272015-02-24 17:39:50 +010086# If JACK_CLASSPATH is not set, assume it only contains core-libart.
87if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070088 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010089fi
90
Sebastien Hertz19ac0272015-02-24 17:39:50 +010091export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080092
Igor Murashkin271a0f82017-02-14 21:14:17 +000093# Zipalign is not on the PATH in some configs, auto-detect it.
94if [ -z "$ZIPALIGN" ]; then
95 if which zipalign >/dev/null; then
96 ZIPALIGN="zipalign";
97 else
98 # TODO: Add a dependency for zipalign in Android.run-test.mk
99 # once it doesn't depend on libandroidfw (b/35246701)
100 case "$OSTYPE" in
101 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
102 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
103 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
104 esac
105 fi
106fi
107export ZIPALIGN
108
jeffhao5d1ac922011-09-29 17:41:15 -0700109info="info.txt"
110build="build"
111run="run"
112expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700113check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700114output="output.txt"
115build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100116cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700117strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700118lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700119testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700120run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000121build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700122
Alex Light91de25f2015-10-28 17:00:06 -0700123quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000124debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700125prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700126target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700127dev_mode="no"
128update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700129debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000130relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800131runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700132usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700133build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700134suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700135trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700136trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700137basic_verify="false"
138gc_verify="false"
139gc_stress="false"
Alex Light8f2c6d42017-04-10 16:27:35 -0700140jvmti_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700141strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700142always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700143never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700144have_dex2oat="yes"
145have_patchoat="yes"
146have_image="yes"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800147multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000148android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700149bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800150suspend_timeout="500000"
Alex Light10bc5a42016-05-10 10:01:22 -0700151# By default we will use optimizing.
152image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000153image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700154
155while true; do
156 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700157 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700158 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100159 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700160 shift
Alex Light91de25f2015-10-28 17:00:06 -0700161 elif [ "x$1" = "x--quiet" ]; then
162 quiet="yes"
163 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700164 elif [ "x$1" = "x--use-java-home" ]; then
165 if [ -n "${JAVA_HOME}" ]; then
166 export JAVA="${JAVA_HOME}/bin/java"
167 export JAVAC="${JAVA_HOME}/bin/javac -g"
168 else
169 echo "Passed --use-java-home without JAVA_HOME variable set!"
170 usage="yes"
171 fi
172 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800173 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700174 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800175 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800176 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700177 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700178 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700179 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100180 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100181 run_args="${run_args} --jvm"
Alex Lighteb7c1442015-08-31 13:17:42 -0700182 build_args="${build_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700183 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800184 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700185 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700186 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700187 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700188 shift
189 elif [ "x$1" = "x--dalvik" ]; then
190 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800191 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700192 shift
Alex Light03a112d2014-08-25 13:25:56 -0700193 elif [ "x$1" = "x--no-dex2oat" ]; then
194 have_dex2oat="no"
195 shift
196 elif [ "x$1" = "x--no-patchoat" ]; then
197 have_patchoat="no"
198 shift
199 elif [ "x$1" = "x--no-image" ]; then
200 have_image="no"
201 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800202 elif [ "x$1" = "x--multi-image" ]; then
203 multi_image_suffix="-multi"
204 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700205 elif [ "x$1" = "x--pic-test" ]; then
206 run_args="${run_args} --pic-test"
207 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700208 elif [ "x$1" = "x--relocate" ]; then
209 relocate="yes"
210 shift
211 elif [ "x$1" = "x--no-relocate" ]; then
212 relocate="no"
213 shift
214 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100215 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700216 prebuild_mode="yes"
217 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700218 elif [ "x$1" = "x--strip-dex" ]; then
219 run_args="${run_args} --strip-dex"
220 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000221 elif [ "x$1" = "x--debuggable" ]; then
222 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000223 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000224 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700225 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100226 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700227 prebuild_mode="no"
228 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700229 elif [ "x$1" = "x--gcverify" ]; then
230 basic_verify="true"
231 gc_verify="true"
232 shift
233 elif [ "x$1" = "x--gcstress" ]; then
234 basic_verify="true"
235 gc_stress="true"
236 shift
Alex Light8f2c6d42017-04-10 16:27:35 -0700237 elif [ "x$1" = "x--jvmti-stress" ]; then
238 jvmti_stress="true"
239 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800240 elif [ "x$1" = "x--suspend-timeout" ]; then
241 shift
242 suspend_timeout="$1"
243 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700244 elif [ "x$1" = "x--image" ]; then
245 shift
246 image="$1"
247 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700248 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000249 elif [ "x$1" = "x-Xcompiler-option" ]; then
250 shift
251 option="$1"
252 run_args="${run_args} -Xcompiler-option $option"
253 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000254 elif [ "x$1" = "x--build-option" ]; then
255 shift
256 option="$1"
257 build_args="${build_args} $option"
258 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700259 elif [ "x$1" = "x--runtime-option" ]; then
260 shift
261 option="$1"
262 run_args="${run_args} --runtime-option $option"
263 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700264 elif [ "x$1" = "x--gdb-arg" ]; then
265 shift
266 gdb_arg="$1"
267 run_args="${run_args} --gdb-arg $gdb_arg"
268 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700269 elif [ "x$1" = "x--debug" ]; then
270 run_args="${run_args} --debug"
271 shift
272 elif [ "x$1" = "x--gdb" ]; then
273 run_args="${run_args} --gdb"
274 dev_mode="yes"
275 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700276 elif [ "x$1" = "x--strace" ]; then
277 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700278 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700279 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700280 elif [ "x$1" = "x--zygote" ]; then
281 run_args="${run_args} --zygote"
282 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800283 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000284 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700285 image_suffix="-interpreter"
286 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800287 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700288 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000289 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800290 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700291 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700292 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800293 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700294 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700295 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700296 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700297 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700298 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700299 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700300 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700301 elif [ "x$1" = "x--no-optimize" ]; then
302 run_args="${run_args} --no-optimize"
303 shift
304 elif [ "x$1" = "x--no-precise" ]; then
305 run_args="${run_args} --no-precise"
306 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700307 elif [ "x$1" = "x--invoke-with" ]; then
308 shift
309 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700310 if [ "x$what" = "x" ]; then
311 echo "$0 missing argument to --invoke-with" 1>&2
312 usage="yes"
313 break
314 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700315 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700316 shift
317 elif [ "x$1" = "x--dev" ]; then
318 run_args="${run_args} --dev"
319 dev_mode="yes"
320 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700321 elif [ "x$1" = "x--build-only" ]; then
322 build_only="yes"
323 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100324 elif [ "x$1" = "x--build-with-javac-dx" ]; then
325 USE_JACK="false"
326 shift
327 elif [ "x$1" = "x--build-with-jack" ]; then
328 USE_JACK="true"
329 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700330 elif [ "x$1" = "x--output-path" ]; then
331 shift
332 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700333 if [ "x$tmp_dir" = "x" ]; then
334 echo "$0 missing argument to --output-path" 1>&2
335 usage="yes"
336 break
337 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700338 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000339 elif [ "x$1" = "x--android-root" ]; then
340 shift
341 if [ "x$1" = "x" ]; then
342 echo "$0 missing argument to --android-root" 1>&2
343 usage="yes"
344 break
345 fi
346 android_root="$1"
347 run_args="${run_args} --android-root $1"
348 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700349 elif [ "x$1" = "x--update" ]; then
350 update_mode="yes"
351 shift
352 elif [ "x$1" = "x--help" ]; then
353 usage="yes"
354 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700355 elif [ "x$1" = "x--64" ]; then
356 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700357 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700358 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200359 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700360 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200361 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700362 elif [ "x$1" = "x--stream" ]; then
363 trace_stream="true"
364 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700365 elif [ "x$1" = "x--always-clean" ]; then
366 always_clean="yes"
367 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700368 elif [ "x$1" = "x--never-clean" ]; then
369 never_clean="yes"
370 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800371 elif [ "x$1" = "x--dex2oat-swap" ]; then
372 run_args="${run_args} --dex2oat-swap"
373 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700374 elif [ "x$1" = "x--instruction-set-features" ]; then
375 shift
376 run_args="${run_args} --instruction-set-features $1"
377 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700378 elif [ "x$1" = "x--bisection-search" ]; then
379 bisection_search="yes"
380 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000381 elif [ "x$1" = "x--vdex" ]; then
382 run_args="${run_args} --vdex"
383 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000384 elif [ "x$1" = "x--vdex-filter" ]; then
385 shift
386 filter=$1
387 run_args="${run_args} --vdex-filter $filter"
388 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700389 elif [ "x$1" = "x--random-profile" ]; then
390 run_args="${run_args} --random-profile"
391 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700392 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700393 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700394 usage="yes"
395 break
396 else
397 break
398 fi
399done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700400
Alex Light10bc5a42016-05-10 10:01:22 -0700401run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700402# Allocate file descriptor real_stderr and redirect it to the shell's error
403# output (fd 2).
404if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
405 exec {real_stderr}>&2
406else
407 # In bash before version 4.1 we need to do a manual search for free file
408 # descriptors.
409 FD=3
410 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
411 real_stderr=$FD
412 eval "exec ${real_stderr}>&2"
413fi
414if [ "$quiet" = "yes" ]; then
415 # Force the default standard output and error to go to /dev/null so we will
416 # not print them.
417 exec 1>/dev/null
418 exec 2>/dev/null
419fi
420
421function err_echo() {
422 echo "$@" 1>&${real_stderr}
423}
424
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700425# tmp_dir may be relative, resolve.
426#
427# Cannot use realpath, as it does not exist on Mac.
428# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700429# Cannot use readlink -m, as it does not exist on Mac.
430# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700431noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700432tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700433mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700434
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800435# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000436if [ ! "$runtime" = "jvm" ]; then
437 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
438fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800439
Alex Lighte7873ec2014-08-12 09:53:50 -0700440if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800441 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
442 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700443fi
444if [ "$gc_verify" = "true" ]; then
445 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
446fi
447if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700448 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700449fi
Alex Light8f2c6d42017-04-10 16:27:35 -0700450if [ "$jvmti_stress" = "true" ]; then
451 run_args="${run_args} --no-app-image --jvmti-stress"
452fi
Jeff Hao85139a32014-07-23 11:52:52 -0700453if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700454 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
455 if [ "$trace_stream" = "true" ]; then
456 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
457 # the ability to analyze the file and just write to /dev/null.
458 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
459 # Enable streaming mode.
460 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
461 else
462 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
463 fi
464elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700465 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700466 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700467fi
468
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700469# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100470# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100471function guess_target_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100472 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800473 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700474 if [ "x${suffix64}" = "x64" ]; then
475 target_arch_name=${grep64bit}
476 else
477 target_arch_name=${grep32bit}
478 fi
479}
480
David Brazdil853a4c32015-09-28 16:15:50 +0100481function guess_host_arch_name() {
482 if [ "x${suffix64}" = "x64" ]; then
483 host_arch_name="x86_64"
484 else
485 host_arch_name="x86"
486 fi
487}
488
Alex Lighta59dd802014-07-02 16:28:08 -0700489if [ "$target_mode" = "no" ]; then
490 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700491 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700492 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700493 exit 1;
494 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700495 fi
496fi
497
Alex Light03a112d2014-08-25 13:25:56 -0700498if [ "$have_patchoat" = "no" ]; then
499 run_args="${run_args} --no-patchoat"
500fi
501
502if [ "$have_dex2oat" = "no" ]; then
503 run_args="${run_args} --no-dex2oat"
504fi
505
Jeff Hao201803f2013-11-20 18:11:39 -0800506if [ ! "$runtime" = "jvm" ]; then
507 run_args="${run_args} --lib $lib"
508fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700509
Jeff Hao201803f2013-11-20 18:11:39 -0800510if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700511 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100512 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800513 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700514 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700515 else
516 true # defaults to using target BOOTCLASSPATH
517 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800518elif [ "$runtime" = "art" ]; then
519 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100520 guess_host_arch_name
Richard Uhlerbb00f812017-02-16 14:21:10 +0000521 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700522 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800523 else
David Brazdil853a4c32015-09-28 16:15:50 +0100524 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800525 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Richard Uhlerbb00f812017-02-16 14:21:10 +0000526 run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800527 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700528 if [ "$relocate" = "yes" ]; then
529 run_args="${run_args} --relocate"
530 else
531 run_args="${run_args} --no-relocate"
532 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700533elif [ "$runtime" = "jvm" ]; then
534 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800535 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700536fi
537
Alex Light03a112d2014-08-25 13:25:56 -0700538if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700539 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700540 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700541 exit 1
542 fi
Alex Light03a112d2014-08-25 13:25:56 -0700543 run_args="${run_args} --no-image"
544fi
545
jeffhao5d1ac922011-09-29 17:41:15 -0700546if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700547 err_echo "--dev and --update are mutually exclusive"
548 usage="yes"
549fi
550
551if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
552 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700553 usage="yes"
554fi
555
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700556if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
557 err_echo "--bisection-search and --prebuild are mutually exclusive"
558 usage="yes"
559fi
560
561if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
562 err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
563 usage="yes"
564fi
565
566if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
567 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
568 usage="yes"
569fi
570
jeffhao5d1ac922011-09-29 17:41:15 -0700571if [ "$usage" = "no" ]; then
572 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
573 test_dir=`basename "$oldwd"`
574 else
575 test_dir="$1"
576 fi
577
578 if [ '!' -d "$test_dir" ]; then
579 td2=`echo ${test_dir}-*`
580 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700581 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700582 usage="yes"
583 fi
584 test_dir="$td2"
585 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700586 # Shift to get rid of the test name argument. The rest of the arguments
587 # will get passed to the test run.
588 shift
589fi
590
Søren Gjesse620d0a52016-09-19 11:12:51 +0200591# For building with javac and dx always use Java 7. The dx compiler
592# only support byte codes from Java 7 or earlier (class file major
593# version 51 or lower).
594if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then
595 export JAVAC="${JAVAC} -source 1.7 -target 1.7"
596fi
597
jeffhao5d1ac922011-09-29 17:41:15 -0700598if [ "$usage" = "yes" ]; then
599 prog=`basename $prog`
600 (
601 echo "usage:"
602 echo " $prog --help Print this message."
603 echo " $prog [options] [test-name] Run test normally."
604 echo " $prog --dev [options] [test-name] Development mode" \
605 "(dumps to stdout)."
606 echo " $prog --update [options] [test-name] Update mode" \
607 "(replaces expected.txt)."
608 echo ' Omitting the test name or specifying "-" will use the' \
609 "current directory."
610 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000611 echo " -O Run non-debug rather than debug build (off by default)."
612 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000613 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000614 echo " --runtime-option Pass an option to the runtime."
615 echo " --debug Wait for a debugger to attach."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000616 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000617 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700618 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000619 echo " --build-only Build test files only (off by default)."
Søren Gjesse620d0a52016-09-19 11:12:51 +0200620 echo " --build-with-javac-dx Build test files with javac and dx (off by default)."
621 echo " --build-with-jack Build test files with jack and jill (on by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000622 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800623 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000624 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000625 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700626 echo " --verify-soft-fail Force soft fail verification (off by default)."
627 echo " Verification is enabled if neither --no-verify"
628 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000629 echo " --no-optimize Turn off optimization (on by default)."
630 echo " --no-precise Turn off precise GC (on by default)."
631 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700632 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000633 echo " other runtime options are ignored."
634 echo " --no-dex2oat Run as though dex2oat was failing."
635 echo " --no-patchoat Run as though patchoat was failing."
636 echo " --prebuild Run dex2oat on the files before starting test. (default)"
637 echo " --no-prebuild Do not run dex2oat on the files before starting"
638 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700639 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000640 echo " --relocate Force the use of relocating in the test, making"
641 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000642 echo " address before running."
643 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700644 echo " --image Run the test using a precompiled boot image. (default)"
645 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000646 echo " --host Use the host-mode virtual machine."
647 echo " --invoke-with Pass --invoke-with option to runtime."
648 echo " --dalvik Use Dalvik (off by default)."
649 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700650 echo " --use-java-home Use the JAVA_HOME environment variable"
651 echo " to find the java compiler and runtime"
652 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000653 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700654 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000655 echo " --64 Run the test in 64-bit mode"
656 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700657 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700658 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000659 echo " --gcstress Run with gc stress testing"
660 echo " --gcverify Run with gc verification"
Alex Light8f2c6d42017-04-10 16:27:35 -0700661 echo " --jvmti-stress Run with jvmti stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000662 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700663 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000664 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000665 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700666 echo " --instruction-set-features [string]"
667 echo " Set instruction-set-features for compilation."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800668 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
669 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700670 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700671 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700672 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000673 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800674 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Alex Light91de25f2015-10-28 17:00:06 -0700675 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700676 exit 1
677fi
678
679cd "$test_dir"
680test_dir=`pwd`
681
682td_info="${test_dir}/${info}"
683td_expected="${test_dir}/${expected}"
684
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700685if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700686 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700687 exit 1
688fi
689
690if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700691 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700692 exit 1
693fi
694
695# copy the test to a temp dir and run it
696
Elliott Hughes510c8782011-10-06 10:57:34 -0700697echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700698
699rm -rf "$tmp_dir"
700cp -Rp "$test_dir" "$tmp_dir"
701cd "$tmp_dir"
702
703if [ '!' -r "$build" ]; then
704 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800705else
706 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700707fi
708
709if [ '!' -r "$run" ]; then
710 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800711else
712 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700713fi
714
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700715if [ '!' -r "$check_cmd" ]; then
716 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800717else
718 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700719fi
720
jeffhao5d1ac922011-09-29 17:41:15 -0700721chmod 755 "$build"
722chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700723chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700724
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700725export TEST_NAME=`basename ${test_dir}`
726
David Brazdil4846d132015-01-15 19:07:08 +0000727# Tests named '<number>-checker-*' will also have their CFGs verified with
728# Checker when compiled with Optimizing on host.
729if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000730 if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$USE_JACK" = "true" ]; then
David Brazdil80fb3942015-07-23 11:53:42 +0100731 # In no-prebuild mode, the compiler is only invoked if both dex2oat and
732 # patchoat are available. Disable Checker otherwise (b/22552692).
Goran Jakovljevic9c4f0d8f2017-04-05 16:27:25 +0200733 if [ "$prebuild_mode" = "yes" ] \
Roland Levillain0d5a2812015-11-13 10:07:31 +0000734 || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then
David Brazdil80fb3942015-07-23 11:53:42 +0100735 run_checker="yes"
David Brazdil5cc343d2015-10-08 11:35:32 +0100736
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100737 if [ "$target_mode" = "no" ]; then
738 cfg_output_dir="$tmp_dir"
David Brazdil5cc343d2015-10-08 11:35:32 +0100739 checker_args="--arch=${host_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100740 else
741 cfg_output_dir="$DEX_LOCATION"
David Brazdil5cc343d2015-10-08 11:35:32 +0100742 checker_args="--arch=${target_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100743 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100744
745 if [ "$debuggable" = "yes" ]; then
746 checker_args="$checker_args --debuggable"
747 fi
748
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100749 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
David Brazdil80fb3942015-07-23 11:53:42 +0100750 -Xcompiler-option -j1"
751 fi
David Brazdil4846d132015-01-15 19:07:08 +0000752 fi
753fi
754
Mathieu Chartier031768a2015-08-27 10:25:02 -0700755 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700756
Richard Uhler020c0f32017-03-14 16:23:17 +0000757# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
758# ART output to approximately 128MB. This should be more than sufficient
759# for any test while still catching cases of runaway output.
760# Set a hard limit to encourage ART developers to increase the ulimit here if
761# needed to support a test case rather than resetting the limit in the run
762# script for the particular test in question.
Orion Hodsonbd328d32017-03-24 11:24:10 +0000763if ! ulimit -f 128000; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000764 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700765fi
766
jeffhao5d1ac922011-09-29 17:41:15 -0700767good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000768good_build="yes"
769good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700770if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000771 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700772 build_exit="$?"
773 echo "build exit status: $build_exit" 1>&2
774 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800775 echo "${test_dir}: running..." 1>&2
776 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700777 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000778
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800779 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000780 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100781 if [ "$target_mode" = "yes" ]; then
782 adb pull $cfg_output_dir/$cfg_output &> /dev/null
783 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100784 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000785 checker_exit="$?"
786 if [ "$checker_exit" = "0" ]; then
787 good="yes"
788 fi
Alex Light91de25f2015-10-28 17:00:06 -0700789 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000790 else
791 good="yes"
792 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800793 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000794 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700795 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700796elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000797 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700798 build_exit="$?"
799 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800800 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700801 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000802 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100803 if [ "$target_mode" = "yes" ]; then
804 adb pull $cfg_output_dir/$cfg_output &> /dev/null
805 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100806 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000807 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700808 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
809 good="yes"
810 else
Alex Light91de25f2015-10-28 17:00:06 -0700811 cat "$build_output" 1>&${real_stderr} 1>&2
812 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700813 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700814elif [ "$build_only" = "yes" ]; then
815 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000816 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700817 build_exit="$?"
818 if [ "$build_exit" '!=' '0' ]; then
819 cp "$build_output" "$output"
820 echo "build exit status: $build_exit" >>"$output"
821 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
822 if [ "$?" '!=' "0" ]; then
823 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700824 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700825 fi
826 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700827 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700828 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700829 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700830else
David Brazdil4846d132015-01-15 19:07:08 +0000831 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700832 build_exit="$?"
833 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800834 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700835 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000836 run_exit="$?"
837 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700838 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000839 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000840 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100841 if [ "$target_mode" = "yes" ]; then
842 adb pull $cfg_output_dir/$cfg_output &> /dev/null
843 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100844 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000845 checker_exit="$?"
846 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700847 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000848 good_run="no"
849 else
850 good_run="yes"
851 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000852 else
853 good_run="yes"
854 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700855 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000856 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700857 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700858 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
859 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700860 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700861 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700862 max_name_length=$(getconf NAME_MAX ${tmp_dir})
863 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
864 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700865 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700866 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700867 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700868 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000869 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
870 # output == expected
871 good="yes"
872 echo "${test_dir}: succeeded!" 1>&2
873 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700874 fi
875fi
876
jeffhao5d1ac922011-09-29 17:41:15 -0700877(
Alex Lightbfac14a2014-07-30 09:41:21 -0700878 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700879 echo "${test_dir}: FAILED!"
880 echo ' '
881 echo '#################### info'
882 cat "${td_info}" | sed 's/^/# /g'
883 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700884 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700885 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700886 if [ "$strace" = "yes" ]; then
887 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700888 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700889 echo '####################'
890 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700891 echo ' '
892 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700893
Alex Light91de25f2015-10-28 17:00:06 -0700894) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700895
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700896# Attempt bisection only if the test failed.
897if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
898 # Bisecting works by skipping different optimization passes which breaks checker assertions.
899 if [ "$run_checker" == "yes" ]; then
900 echo "${test_dir}: not bisecting, checker test." 1>&2
901 else
902 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700903 echo "${test_dir}: bisecting..." 1>&2
904 cwd=`pwd`
905 maybe_device_mode=""
906 raw_cmd=""
907 if [ "$target_mode" = "yes" ]; then
908 # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option
909 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
910 # to exec in order to preserve pid when calling dalvikvm. This is required
911 # for bisection search to correctly retrieve logs from device.
912 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
913 adb shell chmod u+x "$DEX_LOCATION/cmdline.sh"
914 maybe_device_mode="--device"
915 raw_cmd="$DEX_LOCATION/cmdline.sh"
916 else
917 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
918 fi
919 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
920 $maybe_device_mode \
921 --raw-cmd="$raw_cmd" \
922 --check-script="$cwd/check" \
923 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -0700924 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700925 --timeout=300
926 fi
927fi
928
Alex Lightbfac14a2014-07-30 09:41:21 -0700929# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -0700930if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -0700931 cd "$oldwd"
932 rm -rf "$tmp_dir"
933 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
934 adb shell rm -rf $DEX_LOCATION
935 fi
936 if [ "$good" = "yes" ]; then
937 exit 0
938 fi
939fi
940
941
942(
943 if [ "$always_clean" = "yes" ]; then
944 echo "${TEST_NAME} files deleted from host "
945 if [ "$target_mode" == "yes" ]; then
946 echo "and from target"
947 fi
948 else
949 echo "${TEST_NAME} files left in ${tmp_dir} on host"
950 if [ "$target_mode" == "yes" ]; then
951 echo "and in ${DEX_LOCATION} on target"
952 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700953 fi
954
Alex Light91de25f2015-10-28 17:00:06 -0700955) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700956
Alex Light6a870fa2016-05-31 16:36:19 -0700957if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
958 exit 0
959else
960 exit 1
961fi